--[[
	RadarBlip

	By Torgo <jimmcq@concentric.net>, Modified by Unique (contact through Uni Target comments at http://www.curse-gaming.com/mod.php?addid=1064 )

	This mod will add a MiniMap Waypoint (aka Blip) whenever you hear coordinates in the form of "##, ##" on the LocalDefense channel.
	It requires both the MapNotes and Chronos AddOns to be installed.

	Feel free to use any of this code in other mods, or to modify this AddOn itself.  My only request is that you send me your modifications.

	URL: http://curse-gaming.com/mod.php?addid=918
	
   ]]


RadarBlip_Version = "1.2.1";
local icon = 1;
local RadarBlip_ClearDelay = 60;
local RadarBlip_MiniNoteOnly = 1;
local RadarBlip_StartTime = 0;

local coordinateMatch = {
	{ pattern = "(%d+),(%d+)", y = 1, x = 0 },
	{ pattern = "(%d+), (%d+)", y = 1, x = 0 },
	{ pattern = "(%d+).(%d+),(%d+).(%d+)", y2 = 3, y = 2, x1 = 1, x = 0 },
	{ pattern = "(%d+).(%d+), (%d+).(%d+)", y2 = 3, y = 2, x1 = 1, x = 0 },
};


function RadarBlip_OnEvent()
	if (event == "CHAT_MSG_CHANNEL") then
		RadarBlip_Process(arg2, arg1, arg9)	
	elseif (event == "CHAT_MSG_GUILD") then
		RadarBlip_Process(arg2, arg1, "GUILD");
	elseif (event == "CHAT_MSG_PARTY") then
		RadarBlip_Process(arg2, arg1, "PARTY");
	elseif (event == "CHAT_MSG_RAID") then
		RadarBlip_Process(arg2, arg1, "RAID");
	end
end

function RadarBlip_Process(playerName, msgText, channelName)
	local xCoord = nil;
	local yCoord = nil;
	local sender = nil;

	-- Ignore the Trade channel
	if (strfind(channelName, "Trade")) then
		return;
	end
	
	for index, value in coordinateMatch do
		local s, e;
		local results = { };
		s, e, results[0], results[1], results[2], results[3] = string.find(msgText, value.pattern);
		if( results[0] ~= nil ) then
			tmpX = results[value.x] * 1;
			tmpY = results[value.y] * 1;
			if (tmpX > 0 and tmpX < 100 and tmpY > 0 and tmpY < 100) then
				xCoord = string.format("%02d", results[value.x]);
				yCoord = string.format("%02d", results[value.y]);
				zoneName = GetZoneText();
				if (strfind(channelName, zoneName) or strfind(msgText, zoneName) or playerName == UnitName("player")) then
					sender = playerName;
				else
					--SetWhoToUI(RadarBlip);
					SendWho("n-\""..playerName.."\"");
					local numWhoResults = GetNumWhoResults();
					tempArray = { GetMapZones(GetCurrentMapContinent()) }; 
					mapZone = tempArray[GetCurrentMapZone()];
					if (mapZone ~= nil) then
						for i = 1, numWhoResults, 1 do
							tempArray = { GetMapZones(GetCurrentMapContinent()) }; 
							mapZone = tempArray[GetCurrentMapZone()];
							local name, guild, level, race, class, zone, group = GetWhoInfo(i);
							if (name == playerName and zone == mapZone) then
								sender = name;
							end
						end
					end
				end
				
			else
				break;
			end
		end
	end

	if (sender ~= nil) then
		RadarBlip_Ping(xCoord/100, yCoord/100);
		if (playerName ~= UnitName("player")) then
			if (RadarBlip_MiniNoteOnly == 1) then
				MapNotes_NextMiniNoteOnly("on");
			else
				MapNotes_NextMiniNote("on");
			end
			local msg = xCoord..","..yCoord.." "..icon.." "..playerName..": "..msgText;
			MapNotes_Quicktloc(msg);
			RadarBlip_StartTime = GetTime();
			RadarBlip:Show();
		end
	end
end

function RadarBlip_Ping(xPing, yPing)
	local continent, zone = MapNotes_GetZone();
	local x, y = GetPlayerMapPosition("player");
	local xscale = MapNotes_Const[continent][Minimap:GetZoom()].xscale;
	local yscale = MapNotes_Const[continent][Minimap:GetZoom()].yscale;
	if (MapNotes_MiniNote_IsInCity) then
		xscale = xscale * MapNotes_Const[2][Minimap:GetZoom()].cityscale;
		yscale = yscale * MapNotes_Const[2][Minimap:GetZoom()].cityscale;
	end
	local xpos = xPing * MapNotes_Const[continent][zone].scale + MapNotes_Const[continent][zone].xoffset;
	local ypos = yPing * MapNotes_Const[continent][zone].scale + MapNotes_Const[continent][zone].yoffset;
	if (MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()] ~= 0) then
		x = x * MapNotes_Const[GetCurrentMapContinent()][MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()]].scale + MapNotes_Const[GetCurrentMapContinent()][MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()]].xoffset;
		y = y * MapNotes_Const[GetCurrentMapContinent()][MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()]].scale + MapNotes_Const[GetCurrentMapContinent()][MapNotes_ZoneShift[GetCurrentMapContinent()][GetCurrentMapZone()]].yoffset;
	end
	local deltax = (xpos - x) * xscale;
	local deltay = (y - ypos) * yscale;
	if (sqrt( (deltax * deltax) + (deltay * deltay) ) < 56.5) then				
		Minimap:PingLocation(deltax+CURSOR_OFFSET_X, deltay+CURSOR_OFFSET_Y);
	else
		PlaySound("MapPing");
	end
end

function RadarBlip_OnUpdate()
	
	-- Theoretically, we shouldn't be receiving updates if the frame isn't visible, but just to be on the safe side...
	if not (RadarBlip:IsVisible()) then
		return;
	end
	-- If our initial wait time hasn't passed, then return
	if (GetTime() < (RadarBlip_StartTime + RadarBlip_ClearDelay)) then
		return;
	end
	-- Wait time has passed.  Quit receiving updates and start executing version checking
	RadarBlip:Hide();
	-- Go go gadget MiniNote clear :).
	MapNotes_ClearMiniNote();
	--DEFAULT_CHAT_FRAME:AddMessage("RadarBlip MiniNote Cleared", 1.0, 0.0, 0.0);
end